OGRE: Ogre::MaterialManager::Listener Class Reference - OGRE Documentation

Public Member Functions

# Ogre::MaterialManager::Listener Class Reference

Listener on any general material events. More...

`#include <OgreMaterialManager.h>`

List of all members.

## Public Member Functions
virtual | ~Listener ()
| Virtual destructor needed as class has virtual methods.
virtual Technique * | handleSchemeNotFound (unsigned short schemeIndex, const String &schemeName, Material *originalMaterial, unsigned short lodIndex, const Renderable *rend)=0
| Called if a technique for a given scheme is not found within a material, allows the application to specify a Technique instance manually.

## Detailed Description

Listener on any general material events.

See also:
  MaterialManager::addListener

Definition at line 69 of file OgreMaterialManager.h.

## Constructor & Destructor Documentation

virtual Ogre::MaterialManager::Listener::~Listener | ( |  | ) | `[virtual]`

Virtual destructor needed as class has virtual methods.

Definition at line 73 of file OgreMaterialManager.h.

## Member Function Documentation

virtual Technique* Ogre::MaterialManager::Listener::handleSchemeNotFound | ( | unsigned short | schemeIndex,
|  | const String & | schemeName,
|  | Material * | originalMaterial,
|  | unsigned short | lodIndex,
|  | const Renderable * | rend |
| ) |  |  | `[pure virtual]`

Called if a technique for a given scheme is not found within a material, allows the application to specify a Technique instance manually.

Remarks:
  Material schemes allow you to switch wholesale between families of techniques on a material. However they require you to define those schemes on the materials up-front, which might not be possible or desirable for all materials, particular if, for example, you wanted a simple way to replace all materials with another using a scheme.

  This callback allows you to handle the case where a scheme is requested but the material doesn't have an entry for it. You can return a Technique pointer from this method to specify the material technique you'd like to be applied instead, which can be from another material entirely (and probably will be). Note that it is critical that you only return a Technique that is supported on this hardware; there are utility methods like Material::getBestTechnique to help you with this.

Parameters:

  | schemeIndex | The index of the scheme that was requested - all schemes have a unique index when created that does not alter.
  | schemeName | The friendly name of the scheme being requested
  | originalMaterial | The material that is being processed, that didn't have a specific technique for this scheme
  | lodIndex | The material level-of-detail that was being asked for, in case you need to use it to determine a technique.
  | rend | Pointer to the Renderable that is requesting this technique to be used, so this may influence your choice of Technique. May be null if the technique isn't being requested in that context.

Returns:
  A pointer to the technique to be used, or NULL if you wish to use the default technique for this material

The documentation for this class was generated from the following file:

- OgreMaterialManager.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:56